/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.10 by edhill, Thu Oct 9 04:19:20 2003 UTC revision 1.33 by adcroft, Thu Dec 18 15:12:34 2003 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  #  $Header$  #  $Header$
4    #  $Name$
5  #  #
6    
7  usage()  usage()
# Line 12  usage() Line 13  usage()
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mpi)                   use MPI input files"      echo "  (-mpi)                   use MPI input files"
15      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
16        echo "                             (DEF=\"noieee\")"
17      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "  (-optfile=|-of=)STRING   list of optfiles to use"
18      echo "  (-a|-addr)STRING         list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
19      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"edhill@mitgcm.org\")"
20      echo "  (-t|-tdir)STRING         list of test dirs to use"      echo "  (-t|-tdir) STRING        list of test dirs to use"
21      echo "                             (DEF=\"\" which builds all)"      echo "                             (DEF=\"\" which builds all)"
22      echo "  (-b|-bash)STRING         location of \"bash\" executable"      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
23      echo "                             (DEF=\"\" for \"/bin/bash\")"      echo "                             Bourne-compatible \"sh\" shell"
24      echo "  (-command)STRING         command to run"      echo "                             (DEF=\"\" for \"bash\")"
25        echo "  (-adm|-ad)               perform an adjoint run"
26        echo "  (-command) STRING        command to run"
27      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
28      echo "  (-m|-make)STRING         command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
29      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
30      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
31      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
# Line 43  build_mpack() Line 47  build_mpack()
47      echo -n "building the mpack utility...  "      echo -n "building the mpack utility...  "
48      if test ! -x "$MPACKDIR/mpack" ; then      if test ! -x "$MPACKDIR/mpack" ; then
49          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
50                echo
51              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
52              echo "  are you sure this program is being run in the correct "              echo "  are you sure this program is being run in the correct "
53              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"
54              exit 1              echo
55                HAVE_MPACK=f
56          fi          fi
57          echo -n "building mpack...  "          echo -n "building mpack...  "
58          ( cd $MPACKDIR && ./configure && $MAKE ) > build_mpack.out 2>&1          if test "x$CC" = x ; then
59                export CC=cc
60            fi
61            ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
62          RETVAL=$?          RETVAL=$?
63          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
64              echo              echo
65              echo "Error building the mpack tools at: $MPACK_DIR"              echo "Error building the mpack tools at: $MPACK_DIR"
66              exit 1              echo
67                HAVE_MPACK=f
68            else
69                rm -f tr_build_mpack.out
70                HAVE_MPACK=t
71          fi          fi
72        else
73            HAVE_MPACK=t
74      fi      fi
75      echo "OK"      echo "OK"
76  }  }
77    
 compare_lines()  
 {  
     # use codelet to compare lines  
     if [ $verbose -gt 1 ]; then  
         cat tmp3.txt 1>&2  
     fi  
     return `./a.out < tmp3.txt`  
 }  
   
78  testoutput_for_prop()  testoutput_for_prop()
79  {  {
80      # testoutput_for_prop dir s1 label subdir      # testoutput_for_prop dir s1 label subdir
# Line 80  testoutput_for_prop() Line 86  testoutput_for_prop()
86          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2
87      fi      fi
88      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/output.txt ]; then
89          grep "$2" $1/$4/output.txt | sed 's/.*=//' | nl > tmp1.txt          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt
90          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncnt=`wc -l tmp1.txt | awk '{print $1}' `
91          if [ $lncnt -lt 3 ]; then          if [ $lncnt -lt 3 ]; then
92              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
# Line 95  testoutput_for_prop() Line 101  testoutput_for_prop()
101      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
102          echo testoutput_for_prop: grep "$2" $1/results/output.txt 1>&2          echo testoutput_for_prop: grep "$2" $1/results/output.txt 1>&2
103      fi      fi
104      grep "$2" $1/results/output.txt | sed 's/.*=//' | nl > tmp2.txt      grep "$2" $1/results/output.txt | sed 's/.*=//' | cat -n > tmp2.txt
105      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncnt=`wc -l tmp2.txt | awk '{print $1}' `
106      if [ $lncnt -lt 3 ]; then      if [ $lncnt -lt 3 ]; then
107          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
# Line 110  testoutput_for_prop() Line 116  testoutput_for_prop()
116      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
117          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_for_prop: compare_lines 1>&2
118      fi      fi
119      compare_lines      if [ $verbose -gt 1 ]; then
120      digits_of_similarity=$?          cat tmp3.txt 1>&2
121        fi
122        echo "-1" >> tmp3.txt
123        # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
124        cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
125        digits_of_similarity=`./tmp_cmpnum < tmp4.txt`
126      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
127          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
128              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2
# Line 122  testoutput_for_prop() Line 133  testoutput_for_prop()
133              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2
134          fi          fi
135      fi      fi
136      rm tmp1.txt tmp2.txt tmp3.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
137            
138      return $digits_of_similarity      return $digits_of_similarity
139  }  }
# Line 142  dashnum() Line 153  dashnum()
153      done      done
154  }  }
155    
156    testoutput_ad()
157    {
158        grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt
159        grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt
160        grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt
161        grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt
162        join t05.txt t15.txt > t5.txt
163        join t06.txt t16.txt > t6.txt
164        echo "-1" >> t5.txt
165        echo "-1" >> t6.txt
166        digits_5=`./tmp_cmpnum < t5.txt`
167        digits_6=`./tmp_cmpnum < t6.txt`
168        dashnum $digits_5 $digits_6
169        rm -f t[01][56].txt t[56].txt
170    }
171    
172  testoutput()  testoutput()
173  {  {
174      # testoutput diretory subdir      # testoutput directory subdir
175      #      #
176      #  test output in "directory"      #  test output in "directory"
177        if test "x$ADM" = x ; then
178      if [ $debug -gt 0 ]; then          if [ $debug -gt 0 ]; then
179          echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2
180      fi          fi
181      testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2; cg2dres=$?          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2; cg2dres=$?
182      if [ $debug -gt 0 ]; then          if [ $debug -gt 0 ]; then
183          echo testoutput: cg2dres=$cg2dres 1>&2              echo testoutput: cg2dres=$cg2dres 1>&2
184            fi
185            testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2; tmin=$?
186            testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2; tmax=$?
187            testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2; tmean=$?
188            testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2; tsd=$?
189            testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2; smin=$?
190            testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2; smax=$?
191            testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2; smean=$?
192            testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2; ssd=$?
193            testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2; umin=$?
194            testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2; umax=$?
195            testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2; umean=$?
196            testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2; usd=$?
197            testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2; vmin=$?
198            testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2; vmax=$?
199            testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2; vmean=$?
200            testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2; vsd=$?
201            dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \
202                $umin $umax $umean $usd $vmin $vmax $vmean $vsd
203        else
204            testoutput_ad $1 $2 "precision_grdchk_result"
205      fi      fi
       
     testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2; tmin=$?  
     testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2; tmax=$?  
     testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2; tmean=$?  
     testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2; tsd=$?  
     testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2; smin=$?  
     testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2; smax=$?  
     testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2; smean=$?  
     testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2; ssd=$?  
     testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2; umin=$?  
     testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2; umax=$?  
     testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2; umean=$?  
     testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2; usd=$?  
     testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2; vmin=$?  
     testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2; vmax=$?  
     testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2; vmean=$?  
     testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2; vsd=$?  
       
     dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \  
         $umin $umax $umean $usd $vmin $vmax $vmean $vsd  
206  }  }
207    
208  genmakemodel()  genmakemodel()
# Line 186  genmakemodel() Line 214  genmakemodel()
214          GENMAKE2="$BASH ../../../tools/genmake2"          GENMAKE2="$BASH ../../../tools/genmake2"
215          (          (
216              cd $1;              cd $1;
217              command="$GENMAKE2  -ds -m $MAKE --mods=../code"              command="$GENMAKE2  -ds -m $MAKE"
218                if test "x$ADM" = x ; then
219                    command="$command --mods=../code"
220                else
221                    command="$command --mods=../code_ad"
222                    command="$command -adof=../../../tools/adjoint_options/adjoint_staf"
223                fi
224              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
225                  command="$command --optfile=$OPTFILE"                  command="$command --optfile=$OPTFILE"
                 # echo "  command=\"$command\""  
226              fi              fi
227              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
228                  command="$command -ieee"                  command="$command -ieee"
229              fi              fi
             # echo "command: \"$command\""  
230              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
231              $command > make.log 2>&1              $command > make.log 2>&1
232              RETVAL=$?              RETVAL=$?
233              for i in genmake_state genmake_optfile genmake_local Makefile ; do              cp Makefile $CDIR
                 if test -r $i ; then  
                     cp $i $CDIR  
                 fi  
             done  
234              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
235                  tail make.log                  tail make.log
236                  echo "genmakemodel: genmake failed" 1>&2                  echo "genmakemodel: genmake failed" 1>&2
237                  cp make.log $CDIR                  cp genmake_* make.log $CDIR
238                  return 1                  return 1
239              else              else
240                  echo "succesful" 1>&2                  echo "successful" 1>&2
241              fi              fi
242          )          )
243      fi      fi
# Line 237  makeclean() Line 265  makeclean()
265                      return 1                      return 1
266                  fi                  fi
267              fi              fi
268              echo succesful 1>&2              echo successful 1>&2
269              exit 0              exit 0
270          )          )
271      fi      fi
# Line 260  makedependmodel() Line 288  makedependmodel()
288                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
289                  return 1                  return 1
290              else              else
291                  echo succesful 1>&2                  echo successful 1>&2
292              fi              fi
293          )          )
294      fi      fi
# Line 273  makemodel() Line 301  makemodel()
301          cd $1;          cd $1;
302          if test -r Makefile ; then          if test -r Makefile ; then
303              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
304              $MAKE >> make.log 2>&1              if test "x$ADM" = x ; then
305                    $MAKE >> make.log 2>&1
306                else
307                    $MAKE adall >> make.log 2>&1
308                fi
309              RETVAL=$?              RETVAL=$?
310              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
311                  tail make.log                  tail make.log
# Line 281  makemodel() Line 313  makemodel()
313                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
314                  return 1                  return 1
315              else              else
316                  echo succesful 1>&2                  echo successful 1>&2
317              fi              fi
318          fi          fi
319      )      )
320  }  }
321    
322    symlink_mpifiles()
323    {
324        # Put special links so that MPI specific files are used
325        # This MUST be invoked between makeclean and makelinks because
326        # the Makefile will link to non-mpi files by default
327    
328        dir=$1
329        code_dir=$2
330        BUILD_DIR=$dir/$3
331        CODE_DIR=$dir/$code_dir
332    
333        # These are files that should replace their counter-part when using -mpi
334        MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`
335    
336        #  Is this an MPI run?
337        if test "x$MPI" = xt ; then
338            # YES: We symbolically link these files to the build
339            # dir so long as there is no real file in place
340            for ii in $MPI_FILES ; do
341                i=`echo $ii | sed 's:^\./::'`
342                name=`echo $i | sed 's:_mpi::' `
343                cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
344                RETVAL=$?
345                if test "x$RETVAL" != x0 ; then
346                    if ! test -f $BUILD_DIR/$i ; then
347                    #echo Linking $name to $i
348                        (cd $BUILD_DIR; ln -sf ../$code_dir/$i $name)
349                    fi
350                fi
351            done
352        else
353        # NO: We undo any _mpi symbolically linked files
354            for ii in $MPI_FILES ; do
355                i=`echo $ii | sed 's:^\./::'`
356                name=`echo $i | sed 's:_mpi::' `
357                if test -L $BUILD_DIR/$name ; then
358                    linktarg=`(cd $BUILD_DIR; readlink $name)`
359                    if test $linktarg = "../$code_dir/$name"_mpi ; then
360                    #echo Un-linking $name from $linktarg
361                        rm -f $BUILD_DIR/$name
362                    fi
363                fi
364            done
365        fi
366        
367    }
368    
369  linkdata()  linkdata()
370  {  {
371      # linkdata flag      # linkdata flag
372      #      #
373      # symbolically link data files to run directory      # symbolically link data files to run directory
374      if [ $1 -ne 0 ]; then      if test "x$1" = x1 ; then
375          ( cd $2 ;  ln -sf ../input/* . )          (
376                cd $2
377                if test "x$ADM" = x ; then
378                    files=`( cd ../input ; ls -1 | grep -v CVS )`
379                    for i in $files ; do
380                        if test ! -d "../input/"$i ; then
381                            ln -sf "../input/"$i $i
382                        fi
383                    done
384                else
385                    files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`
386                    for i in $files ; do
387                        if test ! -d "../input/"$i ; then
388                            ln -sf "../input/"$i $i
389                        fi
390                    done
391                    files=`( cd ../input_ad ; ls -1 | grep -v CVS )`
392                    for i in $files ; do
393                        if test ! -d "../input_ad/"$i ; then
394                            ln -sf "../input_ad/"$i $i
395                        fi
396                    done
397                fi
398            )
399      fi      fi
400  }  }
401    
# Line 301  runmodel() Line 403  runmodel()
403  {  {
404      # runmodel directory      # runmodel directory
405      #      #
406      #  runs "$COMMAND" in "directory"      #  runs "$COMMAND in "directory"
407      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
408      (      (
409          cd $1          cd $1
410          printf 'runmodel: ' 1>&2          printf 'runmodel ... ' 1>&2
411          # make output.txt          # make output.txt
412          $COMMAND          $COMMAND >> run.log 2>&1
413          RETVAL=$?          RETVAL=$?
414          if test "x$RETVAL" = x0 ; then          if test "x$RETVAL" = x0 ; then
415              cp output.txt $CDIR"/output.txt"              echo successful 1>&2
416                if test "x$ADM" = x ; then
417                    cp output.txt $CDIR"/output.txt"
418                else
419                    cp output.txt_adm $CDIR"/output.txt_adm"
420                fi
421              return 0              return 0
422          else          else
423                tail run.log
424                echo failed 1>&2
425                cp run.log $CDIR"/run.log"
426              return 1              return 1
427          fi          fi
428      )      )
# Line 323  createcodelet() Line 433  createcodelet()
433      # create codelet for comparing model output      # create codelet for comparing model output
434    
435      echo -n "creating the comparison code...  "      echo -n "creating the comparison code...  "
436      cat > tmp_cmpnum.f <<EOFA      cat > tmp_cmpnum.c <<EOF
437        program cmpnum  #include <stdio.h>
438        implicit none  #include <math.h>
439        real*8 a,b,diff  int main( int argc, char** argv )  {
440        integer linnum,best    int linnum,best,lncnt;
441        best=-16    double a,b,diff;
442    99  read(*,*,end=70,err=60) linnum,a,b    best = -16;
443        diff=0.5*(abs(a)+abs(b))    lncnt = 0;
444  c     print *,a,b,diff,abs(a-b)/diff    while( 1 & (lncnt+=1) < 999 )  {
445        if (diff.gt.1.e-12) then      scanf("%d", &linnum);
446          diff=abs(a-b)/diff      if (linnum == -1)  break;
447          if (diff.gt.0.) then      scanf("%lf", &a);  scanf("%lf", &b);
448  c         print *,int(log10(diff)),diff      diff = 0.5*(fabs(a)+fabs(b));
449            linnum=int(log10(diff))      if (diff > 1.e-12) {
450            best=max(best,linnum)        diff=fabs(a-b)/diff;
451          endif        if (diff > 0.0) {
452        else          linnum = (int)log10(diff);
453          if (best.eq.-16.and.diff.ne.0.) best=-22          best = (best > linnum) ? best : linnum;
454        endif        }
455        goto 99        else {
456    60  stop 'cmpnum: An error occured reading a,b'          if (best == -16 && diff != 0)  best = -22;
457    70  print *,-best        }
458        end      }
459  EOFA    }
460      if (lncnt == 999) best=-29;
461      printf("%d\n", -best);
462      return 0;
463    }
464    EOF
465        cc -o tmp_cmpnum tmp_cmpnum.c -lm
466    
467      f77 tmp_cmpnum.f      if [ -x ./tmp_cmpnum ]; then
     if [ -x ./a.out ]; then  
468          echo "OK"          echo "OK"
469          return 0          return 0
470      else      else
471          echo          echo
472          echo "createcodelet: failed to compile codelet"          echo "ERROR: failed to compile comparison code"
473          exit 1          exit 1
474      fi      fi
475  }  }
# Line 414  scandirs() Line 529  scandirs()
529    
530    
531  ###############################################################################  ###############################################################################
 ###############################################################################  
 ###############################################################################  
532    
533    
534  #  Default properties  #  Default properties
# Line 442  OPTFILE=NONE Line 555  OPTFILE=NONE
555  ADDRESSES=  ADDRESSES=
556  TESTDIRS=  TESTDIRS=
557  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
558    HAVE_MPACK=
559  MPACK="$MPACKDIR/mpack"  MPACK="$MPACKDIR/mpack"
560  COMMAND="make output.txt"  COMMAND=
561  MAKE=make  MAKE=make
562  MPI=f  MPI=f
563    
564    ADM=
565    
566  echo -n "parsing options...  "  echo -n "parsing options...  "
567    
568  ac_prev=  ac_prev=
# Line 508  for ac_option ; do Line 624  for ac_option ; do
624          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
625              NODEPEND=t ;;              NODEPEND=t ;;
626    
627          -mpi) MPI=true ;;          -mpi) MPI=t ;;
628    
629            -adm | -ad) ADM=t ;;
630    
631          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
632          -noieee) IEEE= ;;          -noieee) IEEE= ;;
# Line 545  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 663  if test "x$OPTFILE" = xNONE -a "x$MITGCM
663      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
664  fi  fi
665    
666    if test "x$ADM" = xt -a "x$COMMAND" = x ; then
667        COMMAND="./mitgcmuv_ad > output.txt_adm 2>&1"
668    fi
669    
670    if test "x$COMMAND" = x ; then
671        COMMAND="make output.txt"
672    fi
673    
674  echo "OK"  echo "OK"
675    
676  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
677  createcodelet  createcodelet
678    
679  #  build the mpack utility  #  build the mpack utility
680  build_mpack  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
681        echo "skipping mpack build"
682    else
683        build_mpack
684    fi
685    
686  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
687  MACH=`hostname`  MACH=`hostname`
688  UNAMEA=`uname -a`  UNAMEA=`uname -a`
689  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
690  BASE=$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
691  DNUM=0  DNUM=0
692  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
693  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 567  done Line 697  done
697  mkdir $DRESULTS  mkdir $DRESULTS
698  RETVAL=$?  RETVAL=$?
699  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
700      echo "Error: can't create results directory \"./$DRESULTS\""      echo "ERROR: Can't create results directory \"./$DRESULTS\""
701      exit 1      exit 1
702  fi  fi
703  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
704  date > $SUMMARY  echo -n "Start time:  " >> $SUMMARY
705  cat << EOF >> $SUMMARY  start_date=`date`
706    echo $start_date > $SUMMARY
707    
708    of_path=
709    if test "x$OPTFILE" != xNONE ; then
710        if test -r $OPTFILE ; then
711            # get the path
712            path=${OPTFILE%/*}
713            if test "x$path" = x ; then
714                of_path=`pwd`
715            else
716                of_path=`( cd $path > /dev/null 2>&1 ; pwd )`
717            fi
718            file=${OPTFILE##*/}
719            OPTFILE=$of_path/$file
720            cp $OPTFILE $DRESULTS
721            echo >> $SUMMARY
722            echo "  OPTFILE=$OPTFILE" >> $SUMMARY
723        else
724            echo | tee $SUMMARY
725            echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
726            exit 1
727        fi
728    else
729        echo >> $SUMMARY
730        echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
731        echo "   so the genmake default will be used." >> $SUMMARY
732    fi
733    echo
734    echo >> $SUMMARY
735    if test "x$ADM" = x ; then
736        cat << EOF | tee -a $SUMMARY
737                  T           S           U           V                  T           S           U           V
738  G D M    c        m  s        m  s        m  s        m  s  G D M    c        m  s        m  s        m  s        m  s
739  E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .
# Line 580  N n k u  2  i  a  a  d  i  a  a  d  i  a Line 741  N n k u  2  i  a  a  d  i  a  a  d  i  a
741  2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .
742    
743  EOF  EOF
744    else
745        echo "ADJOINT=true" >> $SUMMARY
746        echo >> $SUMMARY
747        cat << EOF | tee -a $SUMMARY
748    G D M    C  G
749    E p a R  o  r
750    N n k u  s  a
751    2 d e n  t  d
752    
753  NDIR=0  EOF
   
 if test "x$OPTFILE" != xNONE ; then  
     if test -r $OPTFILE ; then  
         OPTFILE=`pwd`"/$OPTFILE"  
     fi  
754  fi  fi
 echo  
 echo "OPTFILE=$OPTFILE" >> $SUMMARY  
 echo >> $SUMMARY  
755    
756  #  ...and each test directory...  #  ...and each test directory...
757  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
# Line 608  for dir in $TESTDIRS ; do Line 769  for dir in $TESTDIRS ; do
769    
770      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
771      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
772      if test ! -r $dir"/results/output.txt" ; then      fout=
773          echo "can't read \"$dir/results/output.txt\" -- skipping $dir"      if test "x$ADM" = x ; then
774            fout=$dir"/results/output.txt"
775        else
776            fout=$dir"/results_ad/output.txt_adm"
777        fi
778        if test ! -r $fout ; then
779            echo "can't read \"$fout\" -- skipping $dir"
780            continue
781        fi
782    
783        builddir="input"
784        rundir="input"
785        use_seperate_build=0
786        if test -d $dir/build -a -r $dir/build ; then
787            builddir="build"
788            rundir="build"
789            use_seperate_build=1
790            linkdata $use_seperate_build $dir/$rundir
791        fi
792        
793        if test "x$ADM" = x ; then
794            code_dir=code
795            CODE_DIR=$dir/code
796        else
797            code_dir=code_ad
798            CODE_DIR=$dir/code_ad
799        fi
800        BUILD_DIR=$dir/$builddir
801    
802        if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
803            echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
804          continue          continue
805      fi      fi
806    
# Line 620  for dir in $TESTDIRS ; do Line 811  for dir in $TESTDIRS ; do
811      unset genmake makedepend make run      unset genmake makedepend make run
812      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
813    
     if [ -r $dir/build ]; then  
         seperatebuilddir=1  
         builddir=build  
         rundir=build  
         ( cd $dir/build; ln -sf ../input/* . )  
     else  
         seperatebuilddir=0  
         builddir=input  
         rundir=input  
     fi  
       
     CODE_DIR=$dir/code  
     BUILD_DIR=$dir/$builddir  
     MPI_FILES="CPP_EEOPTIONS.h_mpi SIZE.h_mpi"  
     NOMPI_FILES="CPP_EEOPTIONS.h_nompi SIZE.h_nompi"  
   
     #  Is this an MPI run?  
     if test "x$MPI" = xt ; then  
         FILES=$MPI_FILES  
         endings="_mpi"  
     else  
         FILES=$NOMPI_FILES  
         endings="_nompi"  
     fi  
       
     #  Check to see that we have the files  
     have_files=t  
     for i in $FILES ; do  
         if test ! -r $CODE_DIR/$i ; then  
             echo "Warning: can't read file $CODE_DIR/$i"  
             have_files=f  
         fi  
     done  
     if test "x$have_files" != xt -a "x$MPI" = xt ; then  
         echo "Skipping $dir due to lack of input files (see above warning)"  
         continue  
     fi  
       
     #  If we have the $FILES and they differ, copy the $FILES to $BUILD_DIR  
     if test "x$have_files" = xt ; then  
         for i in $FILES ; do  
             sstr="s|$endings||"  
             name=`echo $i | sed -e $sstr `  
             cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1  
             RETVAL=$?  
             if test "x$RETVAL" != x0 ; then  
                 cp $CODE_DIR/$i $BUILD_DIR/$name  
             fi  
         done  
     fi  
       
814      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
815      CDIR=$DRESULTS"/"$DRESULTS"_"$NDIR      rel_CDIR=$DRESULTS"/"$dir
816      mkdir $CDIR      mkdir $rel_CDIR
817      CDIR=`pwd`"/$CDIR"      CDIR=`pwd`"/$rel_CDIR"
818            
819      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
820          makeclean $dir/$builddir          makeclean $dir/$builddir
821      else      else
822          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
823              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
824                && symlink_mpifiles $dir $code_dir $builddir \
825              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
826              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
827              && linkdata $seperatebuilddir $dir/$rundir \              && linkdata $use_seperate_build $dir/$rundir \
828              && runmodel $dir/$builddir && run=Y \              && runmodel $dir/$rundir && run=Y \
829              && results=`testoutput $dir $rundir`              && results=`testoutput $dir $rundir`
830      fi      fi
831            
832      echo      echo
833      formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \      if test "x$ADM" = x ; then
834          ${run:-N} $results          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
835        else
836            fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
837            fres=$fres"$results   $dir"
838        fi
839      echo      echo
840      formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \      echo "$fres" >> $SUMMARY
841          ${run:-N} $results >> $SUMMARY      echo "fresults='$fres'" > $CDIR"/summary.txt"
     echo "fresults='" > $CDIR"/summary.txt"  
     formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \  
         ${run:-N} $results >> $CDIR"/summary.txt"  
     echo "'" >> $CDIR"/summary.txt"  
842      echo "MACH='$MACH'" >> $CDIR"/summary.txt"      echo "MACH='$MACH'" >> $CDIR"/summary.txt"
843      echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"      echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
844      echo "DATE='$DATE'" >> $CDIR"/summary.txt"      echo "DATE='$DATE'" >> $CDIR"/summary.txt"
845      echo "tdir='$dir'" >> $CDIR"/summary.txt"      echo "tdir='$dir'" >> $CDIR"/summary.txt"
846            
847      (      echo "-------------------------------------------------------------------------------"
         cd $DRESULTS  
         tar -cf $NDIR".tar" $DRESULTS"_"$NDIR > /dev/null 2>&1  
         gzip $NDIR".tar"  
     )  
848            
849      if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  done
850          echo "No mail sent"  
851      else  echo -n "Start time:  " >> $SUMMARY
852          $MPACK -s MITgcm-test -m 1000000 $DRESULTS"/"$NDIR".tar.gz" $ADDRESSES  echo $start_date >> $SUMMARY
853    echo -n "End time:    " >> $SUMMARY
854    date >> $SUMMARY
855    
856    #  If addresses were supplied and mpack built successfully, then try
857    #  to send email using mpack.
858    if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
859        echo "No results email was sent."
860    else
861        if test "x$HAVE_MPACK" = xt ; then
862            tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
863                && gzip $DRESULTS".tar" \
864                && $MPACK -s MITgcm-test -m 1500000 $DRESULTS".tar.gz" $ADDRESSES
865          RETVAL=$?          RETVAL=$?
866          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
867              echo "Warning: \"$MPACK\" failed -- please contact <edhill@mitgcm.org>"              echo
868                echo "Warning: The tar, gzip, & mpack step failed.  Please send email"
869                echo "  to <MITgcm-support@mitgcm.org> for help.  You may copy the "
870                echo "  summary of results from the directory \"$DRESULTS\"."
871                echo
872          else          else
873              rm -f $DRESULTS"/"$NDIR".tar*"              echo
874                echo "An email containing results was sent to the following addresses:"
875                echo "  \"$ADDRESSES\""
876                echo
877          fi          fi
878            test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
879            test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
880      fi      fi
881    fi
882    
883      echo "-------------------------------------------------------------------------------"  # rm -f tmp_cmpnum.f a.out
884        rm -f tmp_cmpnum.c tmp_cmpnum
     NDIR=$(( $NDIR + 1 ))  
       
 done  
   
 rm tmp_cmpnum.f a.out  
885    
886  cat $SUMMARY  if test "x$CLEANUP" != xt ; then
887        cat $SUMMARY
888        if test -e tr_out.txt ; then
889            mv tr_out.txt tr_out.txt.old
890        fi
891        cat $SUMMARY > tr_out.txt
892    fi
893    

Legend:
Removed from v.1.10  
changed lines
  Added in v.1.33

  ViewVC Help
Powered by ViewVC 1.1.22